import { isNumber } from '@/utils/convert'

const state = {
  message: {
    todo: 0,
    done: 0
  },
  system: {
    'systemCode': 0
  }
}

const mutations = {
  UPDATE_MESSAGE: (state, data) => {
    state.message.todo = data.noticeNCount
    state.message.done = data.noticeYCount
  },
  UPDATE_SYSTEM: (state, data) => {
    for (const key in data) {
      state.system[key] = data[key]
    }
  },
  UPDATE_TODO: (state, delta, systemCode) => {
    state.message.todo += delta
    if (!isNumber(state.system[systemCode])) {
      state.system[systemCode] = 0
    }
    state.system[systemCode] += delta
  },
  UPDATE_DONE: (state, delta) => {
    state.message.done += delta
  }
}

const actions = {
  setMessgeCount({ commit }, data) {
    commit('UPDATE_MESSAGE', data)
  },
  setSystemCount({ commit }, data) {
    commit('UPDATE_SYSTEM', data)
  },
  addNewMessage({ commit }, systemCode) {
    commit('UPDATE_TODO', 1, systemCode)
  },
  readMessage({ commit }, systemCode) {
    commit('UPDATE_TODO', -1, systemCode)
    commit('UPDATE_DONE', 1)
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}
